<?xml version='1.0' encoding='UTF-8'?>
<MorpheusModel version="3">
    <Description>
        <Details>Coupled CPM and ODE through CellDivision

- Add a condition to prevent multiple subsequent divisions
  - Property: time of birth
  - Function: age = time - time_of_birth
  - Condition: age() &lt; 10

- Desync divisions:
  - Add noise to Cyclin after cell division
  - Trigger / Rule C = C + rand_uni( -0.25, 0.25 )</Details>
        <Title>Tutorial-CellCyle-SBML</Title>
    </Description>
    <Space>
        <Lattice class="square">
            <Neighborhood>
                <Order>1</Order>
            </Neighborhood>
            <Size symbol="size" value="100, 100, 0"/>
        </Lattice>
        <SpaceSymbol symbol="space"/>
    </Space>
    <Time>
        <StartTime value="0"/>
        <StopTime value="150"/>
        <TimeSymbol symbol="time"/>
    </Time>
    <Global/>
    <Analysis>
        <Logger>
            <Input>
                <Symbol symbol-ref="X"/>
                <Symbol symbol-ref="M"/>
                <Symbol symbol-ref="V1"/>
                <Symbol symbol-ref="V3"/>
                <Symbol symbol-ref="C"/>
            </Input>
            <Output>
                <TextOutput/>
            </Output>
            <Plots>
                <Plot>
                    <Style style="lines"/>
                    <Terminal terminal="png"/>
                    <X-axis>
                        <Symbol symbol-ref="time"/>
                    </X-axis>
                    <Y-axis>
                        <Symbol symbol-ref="X"/>
                        <Symbol symbol-ref="M"/>
                        <Symbol symbol-ref="V1"/>
                        <Symbol symbol-ref="V3"/>
                        <Symbol symbol-ref="C"/>
                    </Y-axis>
                </Plot>
            </Plots>
            <Restriction exclude-medium="true"/>
        </Logger>
        <Gnuplotter time-step="5">
            <Plot>
                <Cells value="V3">
                    <ColorMap>
                        <Color value="1.0" color="red"/>
                        <Color value="0.5" color="yellow"/>
                        <Color value="0" color="white"/>
                    </ColorMap>
                </Cells>
            </Plot>
            <Terminal name="png"/>
        </Gnuplotter>
    </Analysis>
    <CellTypes>
        <CellType class="biological" name="sbml_ct">
            <Property symbol="V1" value="0" name="V1"/>
            <Property symbol="V3" value="0" name="V3"/>
            <Constant symbol="VM1" value="3" name="VM1"/>
            <Constant symbol="VM3" value="1" name="VM3"/>
            <Constant symbol="Kc" value="0.5" name="Kc"/>
            <Property symbol="C" value="0.01" name="Cyclin"/>
            <Property symbol="M" value="0.01" name="CDC-2 Kinase"/>
            <Property symbol="X" value="0.01" name="Cyclin Protease"/>
            <System solver="heun" time-step="0.01">
                <Constant symbol="vi" value="0.025"/>
                <DiffEqn symbol-ref="C" name="gained from reactions">
                    <Expression>0.0 + 1 * vi - C * 1 * kd - C * 1 * vd * X * pow(C + Kd, -1)</Expression>
                </DiffEqn>
                <Constant symbol="kd" value="0.01"/>
                <Constant symbol="vd" value="0.25"/>
                <Constant symbol="Kd" value="0.02"/>
                <Constant symbol="K1" value="0.005"/>
                <DiffEqn symbol-ref="M" name="gained from reactions">
                    <Expression>0.0 + 1 * (1 + -1 * M) * V1 * pow(K1 + -1 * M + 1, -1) - 1 * M * V2 * pow(K2 + M, -1)</Expression>
                </DiffEqn>
                <Constant symbol="V2" value="1.5"/>
                <Constant symbol="K2" value="0.005"/>
                <Constant symbol="K3" value="0.005"/>
                <DiffEqn symbol-ref="X" name="gained from reactions">
                    <Expression>0.0 + 1 * V3 * (1 + -1 * X) * pow(K3 + -1 * X + 1, -1) - 1 * V4 * X * pow(K4 + X, -1)</Expression>
                </DiffEqn>
                <Constant symbol="K4" value="0.005"/>
                <Constant symbol="V4" value="0.5"/>
            </System>
            <Equation symbol-ref="V1">
                <Expression>C * VM1 * pow(C + Kc, -1)</Expression>
            </Equation>
            <Equation symbol-ref="V3">
                <Expression>M * VM3</Expression>
            </Equation>
            <VolumeConstraint target="250" strength="1"/>
            <SurfaceConstraint target="1" mode="aspherity" strength="1"/>
            <Property symbol="tob" value="0.0" name="time of birth"/>
            <CellDivision division-plane="random">
                <Condition>V3 > 0.7 
and age() > 10</Condition>
                <Triggers>
                    <Rule symbol-ref="tob">
                        <Expression>time</Expression>
                    </Rule>
                    <Rule symbol-ref="C">
                        <Expression>V3+rand_uni(0,1)*0.5-0.25</Expression>
                    </Rule>
                </Triggers>
            </CellDivision>
            <Function symbol="age">
                <Expression>time-tob</Expression>
            </Function>
        </CellType>
    </CellTypes>
    <CellPopulations>
        <Population size="0" type="sbml_ct">
            <InitCellObjects mode="distance">
                <Arrangement repetitions="1, 1, 1" displacements="1, 1, 1">
                    <Sphere radius="9" center="size/2"/>
                </Arrangement>
            </InitCellObjects>
        </Population>
    </CellPopulations>
    <CPM>
        <Interaction/>
        <ShapeSurface scaling="norm">
            <Neighborhood>
                <Order>3</Order>
            </Neighborhood>
        </ShapeSurface>
        <MonteCarloSampler stepper="edgelist">
            <MCSDuration value="0.1"/>
            <MetropolisKinetics temperature="1"/>
            <Neighborhood>
                <Order>2</Order>
            </Neighborhood>
        </MonteCarloSampler>
    </CPM>
</MorpheusModel>
